
--NAME = animNew(love.graphics.newImage("IMAGE PATH"), WIDTH, HEIGHT, DURATION)

--[[
local spriteNum = math.floor(NAME.currentTime / NAME.duration * #NAME.quads) + 1
love.graphics.draw(NAME.spriteSheet, NAME.quads[spriteNum])
]]--

function animUpdate(dt)
	--[[
	NAME.currentTime = NAME.currentTime + dt
	if NAME.currentTime >= NAME.duration then
		NAME.currentTime = NAME.currentTime - NAME.duration	
		-- ^ not set to 0 bc of slight lag when that is done
	end		
	]]--
	p1.animCurrent.currentTime = p1.animCurrent.currentTime + dt
	if p1.animCurrent.currentTime >= p1.animCurrent.duration then
		p1.animCurrent.currentTime = p1.animCurrent.currentTime - p1.animCurrent.duration
	end
	p1.weapon.currentTime = p1.weapon.currentTime + dt
	if p1.weapon.currentTime >= p1.weapon.duration then
		p1.weapon.currentTime = p1.weapon.currentTime - p1.weapon.duration
	end
	p1.animLibrary.projectile.currentTime = p1.animLibrary.projectile.currentTime + dt
	if p1.animLibrary.projectile.currentTime >= p1.animLibrary.projectile.duration then
		p1.animLibrary.projectile.currentTime = p1.animLibrary.projectile.currentTime - p1.animLibrary.projectile.duration
	end
end

function animNew(image, width, height, duration)
	local animation = {
		spriteSheet = image,
		quads = {},
		duration = duration or 1,
		currentTime = 0,
		height = height,
		width = width
		}
	for y = 0, image:getHeight() - height, height do
		for x = 0, image:getWidth() - width, width do
			table.insert(animation.quads, love.graphics.newQuad(x, y, width, height, image:getDimensions()))
		end
	end
	return animation
end
