require ('classes')
function p1Load(class)
	p1 = {
		hp = class.hp, 				-- Health
		dmg = class.dmg,			-- Damage
		spd = class.spd,			-- Speed
		dead = false,				-- If Dead true
		delays = {	
			shot = false,			-- If firing a shot true
			shootTick = 0,
			dash = {
				active = false,		-- If Dashing true
				recharge = false,	-- If Charging true
				dormant = true,		-- If Ready True
				},
			dashTick1 = 0,
			dashTick2 = 0,
			},
		animLibrary = {
			idle = class.animLibrary.idle,
			weapon = class.animLibrary.weapon,
			projectile = class.animLibrary.projectile,
			run = {
				U =	class.animLibrary.run.U,
				UL = class.animLibrary.run.UL,
				L = class.animLibrary.run.L,
				LD = class.animLibrary.run.LD,
				D = class.animLibrary.run.D,
				DR = class.animLibrary.run.DR,
				R = class.animLibrary.run.R,
				RU = class.animLibrary.run.RU
				}
			},
		animCurrent = class.animLibrary.idle,
		weapon = class.animLibrary.weapon,					--Picture used for weapon
		pos = { 					-- Location of player
			x=(love.graphics.getWidth()/2) - (class.animLibrary.idle.width/2),
			y=(love.graphics.getHeight()/2) - (class.animLibrary.idle.height/2),
			},
		rot = {						-- Rotation of body & weapon
			weapon = 0,
			},
		projectile = { 				-- player projectile type list
			spd = 250,
			list = {},
		},
		aim = {						-- cursor position
			x=0,
			y=0,
			},
		collision = {
			up = false,
			left = false,
			down = false,
			right = false,
			},
		}
end

function p1Update(dt)
	p1Move(dt)
	p1Aim(dt)
	p1Shoot(dt)
	p1Dash(dt)
end

function p1Move(dt)
	if not p1.dead then
		if love.keyboard.isDown("w","up") then
			if love.keyboard.isDown("a","left") then		--UP & LEFT
				--p1.animCurrent = p1.animLibrary.UL
				if not p1.collision.up then
					moveMap(0, -p1.spd*0.7 * dt)
				end
				if not p1.collision.left then
					moveMap(-p1.spd*0.7 * dt, 0)
				end
			end
			if not love.keyboard.isDown("a","left") and not love.keyboard.isDown("d","right") then	--UP

				if not p1.collision.up then
					moveMap(0, -p1.spd * dt)
				end
			end
		end
		if love.keyboard.isDown("a","left") then
			if love.keyboard.isDown("s","down") then		--LEFT & DOWN

				if not p1.collision.left then
					moveMap(-p1.spd*0.7 * dt, 0)
				end
				if not p1.collision.down then
					moveMap(0, p1.spd*0.7 * dt)
				end
			end
			if not love.keyboard.isDown("w","up") and not love.keyboard.isDown("s","down") then	--LEFT

				if not p1.collision.left then
					moveMap(-p1.spd * dt, 0)
				end
			end
		end
		if love.keyboard.isDown("s","down") then
			if love.keyboard.isDown("d","right") then		--DOWN & RIGHT

				if not p1.collision.down then
					moveMap(0, p1.spd*0.7 * dt)
				end
				if not p1.collision.right then
					moveMap(p1.spd*0.7 * dt, 0)
				end
			end
			if not love.keyboard.isDown("a","left") and not love.keyboard.isDown("d","right") then	--DOWN

				if not p1.collision.down then
					moveMap(0, p1.spd * dt)
				end
			end
		end
		if love.keyboard.isDown("d","right") then
			if love.keyboard.isDown("w","up") then		--RIGHT & UP

				if not p1.collision.right then
					moveMap(p1.spd*0.7 * dt, 0)
				end
				if not p1.collision.up then
					moveMap(0, -p1.spd*0.7 * dt)
				end
			end
			if not love.keyboard.isDown("w","up") and not love.keyboard.isDown("s","down") then	--RIGHT

				if not p1.collision.right then
					moveMap(p1.spd * dt, 0)
				end
			end
		end
	end
end
 
-- function p1CollisionHandler(x,y,mapX,mapY,tilenum,map)
	-- if map[x+math.floor(mapX)][y+math.floor(mapY)] == 3 then --triggered each time tile #3 is found being drawn
		-- collision.x[tilenum] = ((x+math.floor(mapX)-1)*64)
		-- collision.y[tilenum] = ((y+math.floor(mapX)-1)*64)
		-- tilenum = tilenum + 1
		-- print (tilenum)
		-- return tilenum
	-- end
-- end

function p1Aim()
	if not p1.dead then
		p1.aim.x, p1.aim.y = love.mouse.getPosition()
		-- A fix for the x/y mouse coords being 20 pixels off
		p1.aim.x = p1.aim.x - 20
		p1.aim.y = p1.aim.y - 20
		p1.rot.weapon = math.atan2(p1.aim.y - (p1.pos.y - p1.animCurrent.width/2), p1.aim.x - (p1.pos.x - p1.animCurrent.height/2))
	end
end

function p1Shoot(dt)
	if not p1.dead then
		if p1.spd == 2 and not p1.shot and love.mouse.isDown("l") then
			p1.shot = true
			-- p1.weapon = weaponReload
			local projectileDx = p1.projectile.spd * math.cos(p1.rot.weapon)
			local projectileDy = p1.projectile.spd * math.sin(p1.rot.weapon)
			table.insert(p1.projectile.list, {x = p1.pos.x, y = p1.pos.y, dx = projectileDx, dy = projectileDy, rot = p1.rot.weapon})
		end
		if p1.shot then
			p1.delays.shootTick = p1.delays.shootTick + dt
			if p1.delays.shootTick >= .5 then
				p1.delays.shootTick = 0
				--p1.weapon = weaponNormal
				p1.shot = false
			end
		end
		for i,v in ipairs(p1.projectile.list) do
			v.x = v.x + (v.dx * dt)
			v.y = v.y + (v.dy * dt)
		end
	end
end

function p1Dash(dt)
	if not p1.shot and not p1.dead and not p1.delays.dash.recharge and love.keyboard.isDown("shift") then
		p1.spd = 4
		p1.delays.dash.dormant = false
		p1.delays.dash.active = true
		p1.delays.dashTick1 = p1.delays.dashTick1 + dt
		p1.track = track2
		if p1.delays.dashTick1 >= 1 then
			p1.delays.dashTick1 = 0
			p1.delays.dash.active = false
			p1.delays.dash.recharge = true
			p1.spd = 2
		end
	end
	if not p1.dead and p1.delays.dash.recharge then
		p1.track = track3
		p1.delays.dashTick2 = p1.delays.dashTick2 + dt
		if p1.delays.dashTick2 >= 2 then
			p1.delays.dash.recharge = false
			p1.delays.dash.dormant = false
			p1.track = track1
			p1.delays.dashTick2 = 0
		end
	end
end

function p1Draw()
	local spriteNum = math.floor(p1.animCurrent.currentTime / p1.animCurrent.duration * #p1.animCurrent.quads) + 1
	love.graphics.draw(p1.animCurrent.spriteSheet, p1.animCurrent.quads[spriteNum], p1.pos.x - (p1.animCurrent.width/2), p1.pos.y - (p1.animCurrent.height/2), 0, 1, 1)
	for i,v in ipairs(p1.projectile.list) do
		local spriteNum = math.floor(p1.animLibrary.projectile.currentTime / p1.animLibrary.projectile.duration * #p1.animLibrary.projectile.quads) + 1
		love.graphics.draw(p1.animLibrary.projectile.spriteSheet, p1.animLibrary.projectile.quads[spriteNum], v.x, v.y, v.rot, 1, 1, p1.animLibrary.projectile.width/2, p1.animLibrary.projectile.height/2)
	end
	-- love.graphics.draw(p1.weapon, p1.pos.x, p1.pos.y, p1.rot.weapon, 1, 1, weaponNormal:getWidth()/2, weaponNormal:getHeight()/2)
end
